package br.ufes.nemo.seon.ontoloyasservice.generator.lib;

import br.ufes.nemo.seon.ontoloyasservice.oaas.Configuration;
import com.google.common.collect.Iterables;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class LibFilesGenerator extends AbstractGenerator {
  private String PATH_LIB_FILES = "lib/src/";
  
  private String ONTOLOGYSHORTNAME = "";
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Configuration> _filter = Iterables.<Configuration>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Configuration.class);
    for (final Configuration configuration : _filter) {
      {
        boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(this.ONTOLOGYSHORTNAME);
        if (_isNullOrEmpty) {
          this.ONTOLOGYSHORTNAME = configuration.getOntologyShortName().getName().toLowerCase();
        }
        fsa.generateFile((this.PATH_LIB_FILES + "setup.py"), this.setup(configuration));
      }
    }
    fsa.generateFile((this.PATH_LIB_FILES + ".gitignore"), this.gitIgnore());
    fsa.generateFile((this.PATH_LIB_FILES + "pyproject.toml"), this.pyproject());
    fsa.generateFile((this.PATH_LIB_FILES + "sonar-project.properties"), this.sonarCompile());
    fsa.generateFile((this.PATH_LIB_FILES + "publish.sh"), this.publish());
    fsa.generateFile((this.PATH_LIB_FILES + ".gitlab-ci.yml"), this.gitlab());
    fsa.generateFile((this.PATH_LIB_FILES + "requirements.txt"), this.requirements());
    fsa.generateFile((this.PATH_LIB_FILES + "reports/html_reporter.js"), this.html_reports());
    fsa.generateFile((this.PATH_LIB_FILES + "features/steps/README.md"), this.steps());
  }
  
  private CharSequence steps() {
    StringConcatenation _builder = new StringConcatenation();
    return _builder;
  }
  
  private CharSequence html_reports() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("var reporter = require(\'cucumber-html-reporter\');");
    _builder.newLine();
    _builder.append(" ");
    _builder.newLine();
    _builder.append("var options = {");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("name: \"Jira\",");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("theme: \'bootstrap\',");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("jsonFile: \'reports/cucumber.json\',");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("output: \'docs/features/cucumber_report.html\',");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("reportSuiteAsScenarios: true,");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("launchReport: false,");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("metadata: {");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"App Version\":\"0.3.2\",");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"Test Environment\": \"STAGING\",");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"Browser\": \"Chrome  54.0.2840.98\",");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"Platform\": \"Windows 10\",");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"Parallel\": \"Scenarios\",");
    _builder.newLine();
    _builder.append("            ");
    _builder.append("\"Executed\": \"Remote\"");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("}");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("};");
    _builder.newLine();
    _builder.append(" ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("reporter.generate(options);");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence requirements() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("behave==1.2.6");
    _builder.newLine();
    _builder.append("bleach==3.1.4");
    _builder.newLine();
    _builder.append("certifi==2019.11.28");
    _builder.newLine();
    _builder.append("chardet==3.0.4");
    _builder.newLine();
    _builder.append("colorama==0.4.3");
    _builder.newLine();
    _builder.append("commitizen==1.17.1");
    _builder.newLine();
    _builder.append("decli==0.5.1");
    _builder.newLine();
    _builder.append("docutils==0.16");
    _builder.newLine();
    _builder.append("factory-boy==2.12.0");
    _builder.newLine();
    _builder.append("Faker==4.0.2");
    _builder.newLine();
    _builder.append("idna==2.9");
    _builder.newLine();
    _builder.append("importlib-metadata==1.6.0");
    _builder.newLine();
    _builder.append("Jinja2==2.11.1");
    _builder.newLine();
    _builder.append("keyring==21.2.0");
    _builder.newLine();
    _builder.append("MarkupSafe==1.1.1");
    _builder.newLine();
    _builder.append("packaging==20.3");
    _builder.newLine();
    _builder.append("pkginfo==1.5.0.1");
    _builder.newLine();
    _builder.append("prompt-toolkit==3.0.5");
    _builder.newLine();
    _builder.append("psycopg2==2.8.4");
    _builder.newLine();
    _builder.append("Pygments==2.6.1");
    _builder.newLine();
    _builder.append("pyparsing==2.4.6");
    _builder.newLine();
    _builder.append("python-dateutil==2.8.1");
    _builder.newLine();
    _builder.append("questionary==1.5.1");
    _builder.newLine();
    _builder.append("readme-renderer==25.0");
    _builder.newLine();
    _builder.append("requests==2.23.0");
    _builder.newLine();
    _builder.append("requests-toolbelt==0.9.1");
    _builder.newLine();
    _builder.append("six==1.14.0");
    _builder.newLine();
    _builder.append("SQLAlchemy==1.3.15");
    _builder.newLine();
    _builder.append("SQLAlchemy-serializer==1.3.4.2");
    _builder.newLine();
    _builder.append("SQLAlchemy-Utils==0.36.3");
    _builder.newLine();
    _builder.append("termcolor==1.1.0");
    _builder.newLine();
    _builder.append("text-unidecode==1.3");
    _builder.newLine();
    _builder.append("tomlkit==0.5.11");
    _builder.newLine();
    _builder.append("tqdm==4.44.1");
    _builder.newLine();
    _builder.append("twine==3.1.1");
    _builder.newLine();
    _builder.append("urllib3==1.25.8");
    _builder.newLine();
    _builder.append("wcwidth==0.1.9");
    _builder.newLine();
    _builder.append("webencodings==0.5.1");
    _builder.newLine();
    _builder.append("zipp==3.1.0");
    _builder.newLine();
    _builder.append("pdoc");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence gitlab() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("image: nikolaik/python-nodejs:latest");
    _builder.newLine();
    _builder.newLine();
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("PIP_CACHE_DIR: \"$CI_PROJECT_DIR/.cache/pip\"");
    _builder.newLine();
    _builder.newLine();
    _builder.append("cache:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("paths:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- .cache/pip");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- venv/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("stages:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("- test");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("- quality");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("- doc_codigo");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("- doc");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("- deploy");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("test:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("stage: test");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- virtualenv venv");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- source venv/bin/activate");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install -r requirements.txt");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- behave -f json -o reports/report.json");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install coverage");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- coverage erase");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- coverage run --source=\'.\' -m behave");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- coverage xml -i");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("artifacts:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("paths:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- reports/report.json");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- coverage.xml");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("only:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- ($CI_COMMIT_MESSAGE !~ /documentação gerada/ && $CI_COMMIT_MESSAGE !~ /release (\\d+)\\.(\\d+)\\.(\\d+) → (\\d+)\\.(\\d+)\\.(\\d+)/)");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("quality:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("stage: quality");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("image: sonarsource/sonar-scanner-cli:latest");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("SONAR_USER_HOME: \"${CI_PROJECT_DIR}/.sonar\" # Defines the location of the analysis task cache");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("GIT_DEPTH: 0 # Tells git to fetch all the branches of the project, required by the analysis task");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("cache:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("key: ${CI_JOB_NAME}");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("paths:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- .sonar/cache");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- sonar-scanner -Dsonar.qualitygate.wait=true -Dsonar.login=\"${VAR_SONAR_CLOUD_TOKEN}\"");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("only:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- ($CI_COMMIT_MESSAGE !~ /documentação gerada/ && $CI_COMMIT_MESSAGE !~ /release (\\d+)\\.(\\d+)\\.(\\d+) → (\\d+)\\.(\\d+)\\.(\\d+)/)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("      ");
    _builder.newLine();
    _builder.append("doc_codigo:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("stage: doc_codigo");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("before_script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- \'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )\'");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- eval $(ssh-agent -s)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \"$VAR_SSH_PRIVATE_KEY\" | ssh-add -");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.name \"${VAR_GITLAB_USER_NAME}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.email \"${VAR_GITLAB_USER_EMAIL}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- mkdir -p ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- chmod 700 ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- touch ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \"$KNOWN_HOSTS\" >> ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("script: ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git clone ${REPOSITORY_URL}");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- virtualenv venv");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- source venv/bin/activate");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- cd jira");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install -r requirements.txt");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pdoc --html --force jiraX/ --output docs");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git add docs/jiraX/.");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git commit -m \"documentação gerada\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git push");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("only:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- ($CI_COMMIT_BRANCH == \"master\" && $CI_COMMIT_MESSAGE !~ /documentação gerada/ && $CI_COMMIT_MESSAGE !~ /release (\\d+)\\.(\\d+)\\.(\\d+) → (\\d+)\\.(\\d+)\\.(\\d+)/)");
    _builder.newLine();
    _builder.newLine();
    _builder.append("doc:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("stage: doc");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("dependencies: ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- test");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("before_script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- \'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )\'");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- eval $(ssh-agent -s)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \"$VAR_SSH_PRIVATE_KEY\" | ssh-add -");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.name \"${VAR_GITLAB_USER_NAME}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.email \"${VAR_GITLAB_USER_EMAIL}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- mkdir -p ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- chmod 700 ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- touch ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \"$KNOWN_HOSTS\" >> ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git clone ${REPOSITORY_URL}");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- cd jira");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git checkout $CI_COMMIT_BRANCH");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install behave2cucumber");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- python -m behave2cucumber -i ../reports/report.json -o reports/cucumber.json");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- npm install cucumber-html-reporter");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- node reports/html_reporter.js");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git add docs/features/cucumber_report.html # Arquivo gerado");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git commit -m \"documentação gerada\" ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git push");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("rules:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- changes:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- features/**.feature");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("deploy:");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("stage: deploy");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("before_script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- \'which ssh-agent || ( apt-get update -y && apt-get install openssh-client -y )\'");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- eval $(ssh-agent -s)");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \"$VAR_SSH_PRIVATE_KEY\" | ssh-add -");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.name \"${VAR_GITLAB_USER_NAME}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git config --global user.email \"${VAR_GITLAB_USER_EMAIL}\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- mkdir -p ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- chmod 700 ~/.ssh");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- touch ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- echo \t\"$KNOWN_HOSTS\" >> ~/.ssh/known_hosts");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("script:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git clone git@gitlab.com:integration_seon/libs/application/jira.git");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- cd jira");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- rm -rf dist build");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install commitizen");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- cz bump --yes");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- git push");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- python setup.py bdist_wheel");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- pip install twine");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("- python -m twine upload dist/* -u \"${VAR_PYPI_USER_NAME}\" -p \"${VAR_PYPI_PASSWORD}\" --skip-existing");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("only:");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("variables:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("- ($CI_COMMIT_BRANCH == \"master\" && $CI_COMMIT_MESSAGE !~ /documentação gerada/ && $CI_COMMIT_MESSAGE !~ /release (\\d+)\\.(\\d+)\\.(\\d+) → (\\d+)\\.(\\d+)\\.(\\d+)/)");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence publish() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("rm -rf dist build");
    _builder.newLine();
    _builder.append("python setup.py bdist_wheel");
    _builder.newLine();
    _builder.append("python -m twine upload dist/*");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence setup(final Configuration c) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("from setuptools import setup, find_packages");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("with open(\"README.md\", \"r\") as fh:");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("long_description = fh.read()");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("setup(");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("name=\'");
    String _name = c.getOntologyShortName().getName();
    _builder.append(_name, "\t    ");
    _builder.append("_lib\',  # Required");
    _builder.newLineIfNotEmpty();
    _builder.append("\t    ");
    _builder.append("version=\'0.0.1\',  # Required");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("author=\"");
    String _name_1 = c.getAuthor().getName();
    _builder.append(_name_1, "\t    ");
    _builder.append("\",");
    _builder.newLineIfNotEmpty();
    _builder.append("\t    ");
    _builder.append("author_email=\"");
    String _name_2 = c.getAuthor_email().getName();
    _builder.append(_name_2, "\t    ");
    _builder.append("\",");
    _builder.newLineIfNotEmpty();
    _builder.append("\t    ");
    _builder.append("description=\"");
    String _name_3 = c.getAbout().getName();
    _builder.append(_name_3, "\t    ");
    _builder.append("\",");
    _builder.newLineIfNotEmpty();
    _builder.append("\t    ");
    _builder.append("long_description=long_description,");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("long_description_content_type=\"text/markdown\",");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("url=\"");
    String _name_4 = c.getRepository().getName();
    _builder.append(_name_4, "\t    ");
    _builder.append("\",");
    _builder.newLineIfNotEmpty();
    _builder.append("\t    ");
    _builder.append("packages=find_packages(),");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("install_requires=[");
    _builder.newLine();
    _builder.append("\t        ");
    _builder.append("\'SQLAlchemy\', \'SQLAlchemy-Utils\', \'psycopg2\', \'factory-boy\', \'SQLAlchemy-serializer\'");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("],");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("classifiers=[");
    _builder.newLine();
    _builder.append("\t         ");
    _builder.append("\"Programming Language :: Python :: 3\",");
    _builder.newLine();
    _builder.append("\t         ");
    _builder.append("\"License :: OSI Approved :: MIT License\",");
    _builder.newLine();
    _builder.append("\t         ");
    _builder.append("\"Operating System :: OS Independent\",");
    _builder.newLine();
    _builder.append("\t     ");
    _builder.append("],");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.append("setup_requires=[\'wheel\'],");
    _builder.newLine();
    _builder.append("\t    ");
    _builder.newLine();
    _builder.append("\t");
    _builder.append(")");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence pyproject() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("[tool.commitizen]");
    _builder.newLine();
    _builder.append("name = \"cz_conventional_commits\"");
    _builder.newLine();
    _builder.append("version = \"0.0.1\"");
    _builder.newLine();
    _builder.append("tag_format = \"v$version\"");
    _builder.newLine();
    _builder.append("bump_message = \"release $current_version → $new_version\"");
    _builder.newLine();
    _builder.append("version_files = [");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("\"setup.py:version\",");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("\"pyproject.toml:version\",");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("\"sonar-project.properties:sonar.projectVersion\",");
    _builder.newLine();
    _builder.append("]");
    _builder.newLine();
    _builder.newLine();
    _builder.append("style = [");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"qmark\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"question\", \"bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"answer\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"pointer\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"highlighted\", \"fg:#ff9d00 bold\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"selected\", \"fg:#cc5454\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"separator\", \"fg:#cc5454\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"instruction\", \"\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"text\", \"\"],");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("[\"disabled\", \"fg:#858585 italic\"]");
    _builder.newLine();
    _builder.append("]");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence sonarCompile() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("sonar.projectKey = YOUR KEY");
    _builder.newLine();
    _builder.append("sonar.projectName = ");
    _builder.append(this.ONTOLOGYSHORTNAME);
    _builder.append("_lib");
    _builder.newLineIfNotEmpty();
    _builder.append("sonar.projectVersion = 0.0.1");
    _builder.newLine();
    _builder.append("sonar.sources = src");
    _builder.newLine();
    _builder.append("sonar.language = py");
    _builder.newLine();
    _builder.append("sonar.sourceEncoding = UTF-8");
    _builder.newLine();
    _builder.append("sonar.host.url = http://sonarcloud.io");
    _builder.newLine();
    _builder.append("sonar.login = YOUR SONAR LOGIN HASH");
    _builder.newLine();
    _builder.append("sonar.organization = YOUR_ORGANIZATION");
    _builder.newLine();
    _builder.append("sonar.python.coverage.reportPaths = coverage.xml");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence gitIgnore() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("# Byte-compiled / optimized / DLL files");
    _builder.newLine();
    _builder.append("__pycache__/");
    _builder.newLine();
    _builder.append("*.py[cod]");
    _builder.newLine();
    _builder.append("*$py.class");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# C extensions");
    _builder.newLine();
    _builder.append("*.so");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Distribution / packaging");
    _builder.newLine();
    _builder.append(".Python");
    _builder.newLine();
    _builder.append("build/");
    _builder.newLine();
    _builder.append("develop-eggs/");
    _builder.newLine();
    _builder.append("dist/");
    _builder.newLine();
    _builder.append("downloads/");
    _builder.newLine();
    _builder.append("eggs/");
    _builder.newLine();
    _builder.append(".eggs/");
    _builder.newLine();
    _builder.append("lib/");
    _builder.newLine();
    _builder.append("lib64/");
    _builder.newLine();
    _builder.append("parts/");
    _builder.newLine();
    _builder.append("sdist/");
    _builder.newLine();
    _builder.append("var/");
    _builder.newLine();
    _builder.append("wheels/");
    _builder.newLine();
    _builder.append("share/python-wheels/");
    _builder.newLine();
    _builder.append("*.egg-info/");
    _builder.newLine();
    _builder.append(".installed.cfg");
    _builder.newLine();
    _builder.append("*.egg");
    _builder.newLine();
    _builder.append("MANIFEST");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# PyInstaller");
    _builder.newLine();
    _builder.append("#  Usually these files are written by a python script from a template");
    _builder.newLine();
    _builder.append("#  before PyInstaller builds the exe, so as to inject date/other infos into it.");
    _builder.newLine();
    _builder.append("*.manifest");
    _builder.newLine();
    _builder.append("*.spec");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Installer logs");
    _builder.newLine();
    _builder.append("pip-log.txt");
    _builder.newLine();
    _builder.append("pip-delete-this-directory.txt");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Unit test / coverage reports");
    _builder.newLine();
    _builder.append("htmlcov/");
    _builder.newLine();
    _builder.append(".tox/");
    _builder.newLine();
    _builder.append(".nox/");
    _builder.newLine();
    _builder.append(".coverage");
    _builder.newLine();
    _builder.append(".coverage.*");
    _builder.newLine();
    _builder.append(".cache");
    _builder.newLine();
    _builder.append("nosetests.xml");
    _builder.newLine();
    _builder.append("coverage.xml");
    _builder.newLine();
    _builder.append("*.cover");
    _builder.newLine();
    _builder.append(".hypothesis/");
    _builder.newLine();
    _builder.append(".pytest_cache/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Translations");
    _builder.newLine();
    _builder.append("*.mo");
    _builder.newLine();
    _builder.append("*.pot");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Django stuff:");
    _builder.newLine();
    _builder.append("*.log");
    _builder.newLine();
    _builder.append("local_settings.py");
    _builder.newLine();
    _builder.append("db.sqlite3");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Flask stuff:");
    _builder.newLine();
    _builder.append("instance/");
    _builder.newLine();
    _builder.append(".webassets-cache");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Scrapy stuff:");
    _builder.newLine();
    _builder.append(".scrapy");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Sphinx documentation");
    _builder.newLine();
    _builder.append("docs/_build/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# PyBuilder");
    _builder.newLine();
    _builder.append("target/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Jupyter Notebook");
    _builder.newLine();
    _builder.append(".ipynb_checkpoints");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# IPython");
    _builder.newLine();
    _builder.append("profile_default/");
    _builder.newLine();
    _builder.append("ipython_config.py");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# pyenv");
    _builder.newLine();
    _builder.append(".python-version");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# celery beat schedule file");
    _builder.newLine();
    _builder.append("celerybeat-schedule");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# SageMath parsed files");
    _builder.newLine();
    _builder.append("*.sage.py");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Environments");
    _builder.newLine();
    _builder.append(".env");
    _builder.newLine();
    _builder.append(".venv");
    _builder.newLine();
    _builder.append("env/");
    _builder.newLine();
    _builder.append("venv/");
    _builder.newLine();
    _builder.append("ENV/");
    _builder.newLine();
    _builder.append("env.bak/");
    _builder.newLine();
    _builder.append("venv.bak/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Spyder project settings");
    _builder.newLine();
    _builder.append(".spyderproject");
    _builder.newLine();
    _builder.append(".spyproject");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Rope project settings");
    _builder.newLine();
    _builder.append(".ropeproject");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# mkdocs documentation");
    _builder.newLine();
    _builder.append("/site");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# mypy");
    _builder.newLine();
    _builder.append(".mypy_cache/");
    _builder.newLine();
    _builder.append(".dmypy.json");
    _builder.newLine();
    _builder.append("dmypy.json");
    _builder.newLine();
    _builder.newLine();
    _builder.append("# Pyre type checker");
    _builder.newLine();
    _builder.append(".pyre/");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
